package configLoader

type MDWebDavUploaderConfig struct {
    InstanceLink    string `json:"instance"`
    Mail            string `json:"mail"`
    WebDavAuthToken string `json:"token"`
    InstitutionId   int    `json:"institution_id"`
    Parser          string `json:"parser"`
    MetadataFolder  string `json:"metadata_folder"`
    MediaFolder     string `json:"media_folder"`
    PublishOnImport bool   `json:"visible"`
}

type ParserListItem struct {
    name string

}

// Returns a uniform filepath for the configuration of this tool.
// To be compatible across operating systems, this will be a JSON
// file in the same directory as the current programm.
func getConfigFilepath() string {

}

// Loads configuration from the configuration file (located using
// getConfigFilepath()).
func loadFromFile() MDWebDavUploaderConfig {

}

// Returns a uniform filepath for the cache for the list of
// available parsers.
func getParserCacheFilepath() string {

}

// Stores a parser list to a cache file (located via
// getParserCacheFilepath()).
func storeParserList(parserList []ParserListItem) {

}

// Returns a list of the available parsers.
func listParsers() []ParserListItem {

}


// Checks if inputParser is in the list of available parsers.
// Returns the parser name or an error.
func validateParser(inputParser string) (string, error) {

}

// Checks if a directory is the entered directory can be used
// as an source directory for export data. As such, it does need
// to exist.
// Returns the directory name or an error.
func validateDir(dir string) (string, error) {

}

// Validates an input mail address.
// Returns the valid mail address or an eQueries therror.
func validateMail(mail string) (string, error) {

}

// Validates an entered instance URL.
// Returns the entered URL in a unified form (minus optional
// trailing slashes and the /musdb suffix) or an error.
func validateInstanceLink(instanceUrl string) (string, error) {

}

// Validates an institution ID.
// A valid institution ID returns a HTTP 200 response code when queried
// <instance_url> + "/institution/" + institution_id.
// Returns either the entered instance URL or an error.
func validateInstitutionId(institutionId int, instanceUrl string) (int, error) {

}
